# -*- coding: utf-8 -*-
"""
Created on Mon Aug 15 09:15:55 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import


from builtins import super
from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from .individual import individual
from copy import deepcopy
from ..struct.coordinate import coordinate


class numeric(individual):
    type = 'ind-numeric'

    def __init__(self, sort, value = None, *args, **kwargs):
        super(numeric, self).__init__(sort)
        if value is None:
            self.value = 0
        else:
            self.value = coordinate(value)
                
    def printVal(self):
        return str(self.value)   
                 
    def equals(self, other):
        return (self.value == other.value)
        
    def compareValue(self, other):
        if self.value > other.value:
            return 1
        elif self.value == other.value:
            return 0
        return -1    
        
    def replicateInd(self):
        return numeric(self.sort, self.value)
        
    @staticmethod
    def parse(reader, sort):
        neg = False
        if reader.token() == '-':
            reader.newToken()
            neg = True
        num = reader.value()
        ind = numeric(sort, num)
        if neg:
            ind.value = - ind.value
        reader.newToken()
        return ind
        
    #-------------------------------------------------------------
"""
    def toStringInd(self):
        return 
    def parse(self):
        return    
""" 